% Calcul de la matrice de rigidit lmentaire des lments de type 4

% proprits lmentaires 
%       prelel(1,1) : module d'Young
%       prelel(1,2) : coefficient de Poisson
%       prelel(1,3) : 0 = contraintes planes, 1 = dformations planes
%       prelel(1,4) : masse spcifique
%       prelel(1,5) : force de volume de sens x
%       prelel(1,6) : force de volume de sens y

% matrice de rigidit lmentaire

    % calcul du nombre, des coordonnes et des poids des points de Gauss
	ipg = 4; 
	kk = 1/sqrt(3);
	cpg   = [1,1,1,1]; 
	ksipg = [-kk, kk, kk,-kk];
	etapg = [-kk,-kk, kk, kk];
	
	% calcul de la matrice Pn et de son inverse
	inel = 8 ; % nombre de noeuds de l'lment
	ksii = [-1,0 , 1, 1, 1,0,-1,-1]; 
	etai = [-1,-1,-1, 0, 1,1, 1, 0]; 
	pn = zeros(inel,inel);
	for in = 1:inel
	   k  = ksii(in); k2=k*k;
	   e  = etai(in); e2=e*e;
	   pn(in,:) = [1,k,e,k2,k*e,e2,k2*e,k*e2];
	end
	pninv = inv(pn);
	
	% calcul des valeurs des fonctions de forme de rfrence aux PG
	ni = zeros(ipg,inel); nki = ni; nei = ni;
	for ig=1:ipg
	    k  = ksipg(1,ig); k2=k*k;
	    e  = etapg(1,ig); e2=e*e;    
	    ni(ig,:)  = [1,k,e,k2 ,k*e,e2 ,k2*e ,k*e2 ] * pninv;
		nki(ig,:) = [0,1,0,2*k,e  ,0  ,2*k*e,e2   ] * pninv;
		nei(ig,:) = [0,0,1,0  ,k  ,2*e,k2   ,2*k*e] * pninv;

	end
	
	% initialiser la rigidit lmentaire
	idle = inel * ndln;
	ke = zeros(idle,idle);
	% construction de la matrice D
	e =  prelel(1,1); nu = prelel(1,2); a = prelel(1,3);
	c1 = e*(1-a*nu)/((1+nu)*(1-nu-a*nu));
	c2 = c1*nu/(1-a*nu);
	c3 = e/(2*(1+nu));
	D = [c1, c2,  0; ...
	     c2, c1,  0; ...
		  0,  0, c3];
    % initialiser la matrice B
	B = zeros(3,16);
	point_B = [1,3,5,7,9,11,13,15];
	
    % boucle sur les points de Gauss
	for ig=1:ipg
	  % calcul du jacobien jac, de son inverse jinv, et de son dterminant detj
	  jac = [nki(ig,:);nei(ig,:)] * xnel; 
	  jinv = inv(jac); detj = det(jac);
	  % calcul des drives des fonctions de forme sur l'lment rel
	  nxi = jinv(1,:) * [nki(ig,:);nei(ig,:)];
	  nyi = jinv(2,:) * [nki(ig,:);nei(ig,:)];
	  % construction de la matrice B
	  B(1,point_B)   = nxi;  % eps_x
	  B(2,1+point_B) = nyi;  % eps_y
	  B(3,point_B)   = nyi;  % eps_xy 
	  B(3,1+point_B) = nxi;
	  % multiplier la matrice D par (poids de Gauss * detj)
	  D1 = D * cpg(ig) * detj;
	  % mise  jour de la matrice de rigidit au PG
	  ke = ke + B' * D1 * B;
	end
   
