% Calcul de la matrice de rigidit lmentaire des lments de type 5

% proprits lmentaires 
%       prelel(1,1) : module d'Young
%       prelel(1,2) : coefficient de Poisson
%       prelel(1,3) : non utilis
%       prelel(1,4) : masse spcifique
%       prelel(1,5) : force de volume de sens x
%       prelel(1,6) : force de volume de sens y
%       prelel(1,7) : force de volume de sens z

% matrice de rigidit lmentaire

    % calcul du nombre, des coordonnes et des poids des points de Gauss
	ipg = 8; 
	kk = 1/sqrt(3);
	cpg   = [1,1,1,1,  1,1,1,1]; 
	ksipg = [-kk, kk, kk,-kk,  -kk, kk, kk,-kk];
	etapg = [-kk,-kk, kk, kk,  -kk,-kk, kk, kk];
	dzepg = [-kk,-kk,-kk,-kk,   kk, kk, kk, kk];
	
	% calcul de la matrice Pn et de son inverse
	inel = 8 ; % nombre de noeuds de l'lment
	ksii = [-1, 1, 1,-1,  -1, 1, 1,-1]; 
	etai = [-1,-1, 1, 1,  -1,-1, 1, 1]; 
	dzei = [-1,-1,-1,-1,   1, 1, 1, 1];
	pn = zeros(inel,inel);
	for in = 1:inel
	   k  = ksii(in); 
	   e  = etai(in); 
	   dz = dzei(in);
	   pn(in,:) = [1,k,e,dz,k*e,e*dz,k*dz,k*e*dz];
	end
	pninv = inv(pn);
	
	% calcul des valeurs des fonctions de forme de rfrence aux PG
	ni = zeros(ipg,inel); nki = ni; nei = ni; ndi = ni;
	for ig=1:ipg
	    k  = ksipg(1,ig);
	    e  = etapg(1,ig);
		dz = dzepg(1,ig);	    
	    ni(ig,:)  = [1,k,e,dz,k*e,e*dz,k*dz,k*e*dz] * pninv;
		nki(ig,:) = [0,1,0,0 ,e  ,0   ,dz  ,e*dz  ] * pninv;
		nei(ig,:) = [0,0,1,0 ,k  ,dz  ,0   ,k*dz  ] * pninv;
		ndi(ig,:) = [0,0,0,1 ,0  ,e   ,k   ,k*e   ] * pninv;
	end
	
	% initialiser la rigidit lmentaire
	idle = inel * ndln;
	ke = zeros(idle,idle);
	% construction de la matrice D
	e =  prelel(1,1); nu = prelel(1,2);
	c1 = e*(1-nu)/((1+nu)*(1-2*nu));
	c2 = c1*nu/(1-nu);
	c3 = e/(2*(1+nu));
	D = [c1, c2, c2,  0,  0,  0; ...
	     c2, c1, c2,  0,  0,  0; ...
		 c2, c2, c1,  0,  0,  0; ...
		  0,  0,  0, c3,  0,  0; ...
		  0,  0,  0,  0, c3,  0; ...
		  0,  0,  0,  0,  0, c3];
    % initialiser la matrice B
	B = zeros(6,24);
	point_B = [1,4,7,10,13,16,19,22];
	
    % boucle sur les points de Gauss
	for ig=1:ipg
	  % calcul du jacobien jac, de son inverse jinv, et de son dterminant detj
	  jac = [nki(ig,:);nei(ig,:);ndi(ig,:)] * xnel; 
	  jinv = inv(jac); detj = det(jac);
	  % calcul des drives des fonctions de forme sur l'lment rel
	  nxi = jinv(1,:) * [nki(ig,:);nei(ig,:);ndi(ig,:)];
	  nyi = jinv(2,:) * [nki(ig,:);nei(ig,:);ndi(ig,:)];
	  nzi = jinv(3,:) * [nki(ig,:);nei(ig,:);ndi(ig,:)];
	  % construction de la matrice B
	  B(1,point_B)   = nxi;  % eps_x
	  B(2,1+point_B) = nyi;  % eps_y
	  B(3,2+point_B) = nzi;  % eps_z
	  B(4,point_B)   = nyi;  % eps_xy 
	  B(4,1+point_B) = nxi;
	  B(5,1+point_B) = nzi;  % eps_yz
	  B(5,2+point_B) = nyi;
	  B(6,point_B)   = nzi;  % eps_xz 
	  B(6,2+point_B) = nxi;
	  % multiplier la matrice D par (poids de Gauss * detj)
	  D1 = D * cpg(ig) * detj;
	  % mise  jour de la matrice de rigidit au PG
	  ke = ke + B' * D1 * B;
	end
   
